function [newcriterion,P,Q]=AE(P,Q,X,m,n,K,L,variance)
%This function performs the alternating exchanges algorithm

sumP=sum(P);
sumQ=sum(Q);
%calculate V
V=P'*X*Q./(sumP'*sumQ);
%initial values of criterion
newcriterion=1-sumsqr(X-P*V*Q')/variance;
oldcriterion=-1;
while (newcriterion>oldcriterion)
    oldcriterion=newcriterion;
    %   try to improve P
    for rowP=1:n
        columnPold=P(rowP,:)*(1:K)';
        if  sumP(columnPold)>1
            tempP=P;
            temp=X(rowP,:)*Q;
            XQdivsumQ=temp./sumQ;            
            for columnP=1:K
                if columnP~=columnPold
                    %transfer object
                    tempP(rowP,:)=0;
                    tempP(rowP,columnP)=1;
                    %update V
                    Voldclus=V(columnPold,:);
                    Vnewclus=V(columnP,:);
                    cardold=sumP(columnPold);
                    cardnew=sumP(columnP);
                    Vtempnewclus=Vnewclus*cardnew+XQdivsumQ;
                    Vtempnewclus=Vtempnewclus/(cardnew+1);                    
                    Vtempoldclus=Voldclus*cardold-XQdivsumQ;
                    Vtempoldclus=Vtempoldclus/(cardold-1);
                    diffcriterion=sumQ*(cardnew*(Vnewclus-Vtempnewclus).^2+ cardold*(Voldclus-Vtempoldclus).^2)'...
                        +(Vtempoldclus-Vtempnewclus)*(2*temp-sumQ.*(Vtempnewclus+Vtempoldclus))';
                    if diffcriterion<0
                        newcriterion=newcriterion-diffcriterion/variance;
                        P=tempP;
                        sumP=sum(P);
                        V(columnP,:)=Vtempnewclus;
                        V(columnPold,:)=Vtempoldclus;
                        columnPold=columnP;
                    end
                end
            end
        end
    end
    %try to improve Q
    for rowQ=1:m
         columnQold=Q(rowQ,:)*(1:L)';
        if  sumQ(columnQold)>1
            tempQ=Q;
            temp=P'*X(:,rowQ);      
            PtXdivsumP=temp./sumP';
            for columnQ=1:L
                if columnQ~=columnQold
                    tempQ(rowQ,:)=0;
                    tempQ(rowQ,columnQ)=1;
                    Voldclus=V(:,columnQold);
                    Vnewclus=V(:,columnQ);
                    cardold=sumQ(columnQold);
                    cardnew=sumQ(columnQ);
                    Vtempnewclus=Vnewclus*cardnew+ PtXdivsumP;
                    Vtempnewclus=Vtempnewclus/(cardnew+1);
                    Vtempoldclus=Voldclus*cardold- PtXdivsumP;
                    Vtempoldclus=Vtempoldclus/(cardold-1);
                    diffcriterion=sumP*(cardnew*(Vnewclus-Vtempnewclus).^2+ cardold*(Voldclus-Vtempoldclus).^2)...
                        +(Vtempoldclus-Vtempnewclus)'*(2*temp-sumP(:).*(Vtempnewclus+Vtempoldclus));
                     if diffcriterion<0
                        newcriterion=newcriterion-diffcriterion/variance;
                        Q=tempQ;
                        sumQ=sum(Q);
                        V(:,columnQ)=Vtempnewclus;
                        V(:,columnQold)=Vtempoldclus;
                        columnQold=columnQ;
                    end
                end
            end
        end
    end
end