function [bestcriterion, Pbest,Qbest]=simanneal(P,Q,X,m,n,K,L,variance,temperature,gamma,maxiter,maxnnotfrozen)
%This function performs the simulated annealing optimization method for
%two-mode partitioning.
sumP=sum(P);
sumQ=sum(Q);
%calculate V
V=P'*X*Q./(sumP'*sumQ);
oldcriterion=1-sumsqr(X-P*V*Q')/variance;
%initialize vaf
bestcriterion=oldcriterion;
Pbest=P;
Qbest=Q;
nnotfrozen=0;
while nnotfrozen<maxnnotfrozen
    %initialize notfrozen flag
    notfrozen=0;
    % perform maxiter steps
    for i=1:maxiter
        %   choose the mode at random
        if rand>0.5
            tempP=P;
            %choose a row object which is not in a cluster by itself
            rowP=ceil(n*rand);
            columnPold=P(rowP,:)*(1:K)';
            while sumP(columnPold)==1
                rowP=ceil(n*rand);
                columnPold=P(rowP,:)*(1:K)';
            end
            %choose a new cluster for this object, which is not equal to the current cluster
            columnP=ceil(K*rand);
            while columnP==columnPold
                columnP=ceil(K*rand);
            end
            temp=X(rowP,:)*Q;
            XQdivsumQ=temp./sumQ;
            %transfer the object
            tempP(rowP,columnPold)=0;
            tempP(rowP,columnP)=1;
            Voldclus=V(columnPold,:);
            Vnewclus=V(columnP,:);
            cardold=sumP(columnPold);
            cardnew=sumP(columnP);
            Vtempnewclus=Vnewclus*cardnew+XQdivsumQ;
            Vtempnewclus=Vtempnewclus/(cardnew+1);
            Vtempoldclus=Voldclus*cardold-XQdivsumQ;
            Vtempoldclus=Vtempoldclus/(cardold-1);
            diffcriterion=-(sumQ*(cardnew*(Vnewclus-Vtempnewclus).^2+ cardold*(Voldclus-Vtempoldclus).^2)'...
                +(Vtempoldclus-Vtempnewclus)*(2*temp-sumQ.*(Vtempnewclus+Vtempoldclus))')/variance;
            %decide whether to accept the transfer
            if exp(diffcriterion/temperature)>rand
                oldcriterion=oldcriterion+diffcriterion;
                if oldcriterion>bestcriterion
                    bestcriterion=oldcriterion;
                    Pbest=tempP;
                    Qbest=Q;
                end
                P=tempP;
                sumP(columnP)=sumP(columnP)+1;
                sumP(columnPold)=sumP(columnPold)-1;
                if diffcriterion>0
                    notfrozen=1;
                end
                V(columnP,:)=Vtempnewclus;
                V(columnPold,:)=Vtempoldclus;
            end
        else
            tempQ=Q;
            rowQ=ceil(m*rand);
            columnQold=Q(rowQ,:)*(1:L)';
            while sumQ(columnQold)==1
                rowQ=ceil(m*rand);
                columnQold=Q(rowQ,:)*(1:L)';
            end
            columnQ=ceil(L*rand);
            while columnQ==columnQold
                columnQ=ceil(L*rand);
            end
            temp=P'*X(:,rowQ);
            PtXdivsumP=temp./sumP';
            tempQ(rowQ,columnQold)=0;
            tempQ(rowQ,columnQ)=1;
            Voldclus=V(:,columnQold);
            Vnewclus=V(:,columnQ);
            cardold=sumQ(columnQold);
            cardnew=sumQ(columnQ);
            Vtempnewclus=Vnewclus*cardnew+ PtXdivsumP;
            Vtempnewclus=Vtempnewclus/(cardnew+1);
            Vtempoldclus=Voldclus*cardold- PtXdivsumP;
            Vtempoldclus=Vtempoldclus/(cardold-1);
            diffcriterion=-(sumP*(cardnew*(Vnewclus-Vtempnewclus).^2+ cardold*(Voldclus-Vtempoldclus).^2)...
                +(Vtempoldclus-Vtempnewclus)'*(2*temp-sumP(:).*(Vtempnewclus+Vtempoldclus)))/variance;
            if exp(diffcriterion/temperature)>rand
                oldcriterion=oldcriterion+diffcriterion;
                if oldcriterion>bestcriterion
                    bestcriterion=oldcriterion;
                    Pbest=P;
                    Qbest=tempQ;
                end
                Q=tempQ;
                sumQ(columnQ)=sumQ(columnQ)+1;
                sumQ(columnQold)=sumQ(columnQold)-1;
                if diffcriterion>0
                    notfrozen=1;
                end
                V(:,columnQ)=Vtempnewclus;
                V(:,columnQold)=Vtempoldclus;
            end
        end
    end
    %update stats
    temperature=temperature*gamma;
    if notfrozen==0
        nnotfrozen=nnotfrozen+1;
    else
        nnotfrozen=0;
    end
end